// mailer.cpp : Defines the entry point for the application.
//sample of uuencode, uu-decode and base64encode
//author: Selin Dmitry <s_Daemon@yahoo.com>

#include "stdafx.h"
#include <winsock2.h>
#include "string.h"
#include "stdlib.h"

WSADATA W;
SOCKET Sock;
struct sockaddr_in Saddr;
int res,err;
unsigned long mask=127;
char text[1024];
HANDLE FileData;
DWORD nReadBytes;

const char uucode[]="`!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_";
const char base64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"; 


long uuencode(const char* FileName, char* buffer,unsigned  int length)//   uuencode     ,    ,      -  0     
{
	unsigned char ReadData[45];// 
	unsigned char ResData[61];// 
	unsigned long p=0;
	unsigned long len=0;
	unsigned long CurResBufferPos=0;//         
	unsigned int j;
	unsigned char tmpchar;
	FileData=CreateFile(FileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	if(FileData==INVALID_HANDLE_VALUE) return 0;
	
	do
	{
		memset(ReadData,0,45);//  ,  ,     ***   
							 //  nReadBytes,  ,  i     3,
							 //      ,      
		ReadFile(FileData,ReadData,45,&nReadBytes,NULL);//  45 
		if (nReadBytes==0) return len;//  ,     45.     0 ,        .
		// .
		j=1;//  ResData   1   (  0)    
		ResData[0]=nReadBytes;//    . -1  ,           uucode.     .

		for(unsigned int i=0;i<nReadBytes;i+=3)//   
		{
			//memcpy(&p,ReadData+i,3);// . .
			//        (    .
			//  3  4.
			p=ReadData[i+2]+ReadData[i+1]*256+ReadData[i]*65536;// ***
			for(unsigned char i1=0;i1<3;i1++)
			{
				tmpchar=p;
				tmpchar<<=2;//  6 
				tmpchar>>=2;//
				ResData[j+3-i1]=tmpchar;
				p>>=6;//   6 
			}
			ResData[j]=p;// p    6 .      .
			j+=4;
		}

		len+=j+1;//j -    ResData,    -  
		
		//       
		if(len<=length)//    
		{
			for(unsigned char i1=0;i1<j;i1++)//  j 
			{
				buffer[CurResBufferPos+i1]=uucode[ResData[i1]];//-1   uucode    
			}
			
			buffer[CurResBufferPos+j]='\n';
			CurResBufferPos+=j+1;
		}
		else return 0;
		

	}
	while(nReadBytes==45);


	CloseHandle(FileData);
	return len;
}

long uudecode(const char* buffer, unsigned int len, const char* FileName)//  ,    uuecncode     .
{
	unsigned char CodedData[61];// 
	unsigned char DecodedData[45];// 
	unsigned long p=0;
	unsigned long CurbufferPos=0;// ,      buffer
	unsigned char t_len,CodedDataLen=61;
	unsigned char DecodedDataLen=0;
	unsigned long TotalLen=0;
	char* pos;
	FileData=CreateFile(FileName,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0);
	
	while(CurbufferPos<len)
	{
		if(buffer[CurbufferPos]=='\r'||buffer[CurbufferPos]=='\n')
		{
			CurbufferPos++;// -  
		}
		else
		{
			//     ,   
			if(CurbufferPos+61<=len)//  buffer+CurbufferPos ( )   61 ,   
			{
				memcpy(CodedData,buffer+CurbufferPos,61);
				CurbufferPos+=61;
//				CodedDataLen=61; //  ,  CodedDataLen    = 61,      ,       
			}
			else
			{
				
//				r_len=t_len*4/3+3;//+3,     1       4 (    ).
//				if(r_len>61)r_len=61;//  .   +3 -  
				
				memcpy(CodedData,buffer+CurbufferPos,CodedDataLen=len-CurbufferPos);//!!!
				while(CodedData[CodedDataLen-1]=='\r'||CodedData[CodedDataLen-1]=='\n')CodedDataLen--;//      -  ,  .
				memset(CodedData+CodedDataLen,0,61-CodedDataLen);//  ,  CodedData   - ,   .
				CurbufferPos=len;
			}
			pos=strchr(uucode,CodedData[0]);
			if(pos==NULL)
				return 0;
			t_len=pos-uucode;//  ,  .

			// 
			for(unsigned char i=1;i<CodedDataLen;i+=4)//    ,       (),   .
			{
				//  4  
				for( char i1=3;i1>=0;i1--)
				{
					//CodedData[i+i1]- ,     .
					pos=strchr(uucode,CodedData[i+i1]);
					if(pos==NULL)
						return 0;//-   ,    . .
					p+=(pos-uucode)*16777216;//      4-,   ,  .   ,  -   ,    4- =-   .
					p>>=6;
				}
				
				//   p   
				for( i1=2;i1>=0;i1--)
				{
					DecodedData[DecodedDataLen+i1]=p;
					p>>=8;
				}
				DecodedDataLen+=3;
			}
			
			//  .
			WriteFile(FileData,DecodedData,t_len,&nReadBytes,0);
			DecodedDataLen=0;//        .
			TotalLen+=t_len;
		}
	}//end while
	CloseHandle(FileData);
	return TotalLen;
}
long base64encode(const char* FileName, char* buffer,unsigned  int length)//   base64,     ,    ,      -  0     
{
	// , ,          . 
	//      45 ,         uu- .
	unsigned char ReadData[57];// 
	unsigned char ResData[76];// 
	unsigned long p=0;
	unsigned long len=0;	
	unsigned long SourceLen=0;//  .
	unsigned long CurResBufferPos=0;//         
	unsigned int j;
	unsigned char tmpchar;
	FileData=CreateFile(FileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	if(FileData==INVALID_HANDLE_VALUE) return 0;
	
	do
	{
		memset(ReadData,0,57);//  ,  ,     ***   
							 //  nReadBytes,  ,  i     3,
							 //      ,      
		ReadFile(FileData,ReadData,57,&nReadBytes,NULL);//  45 
		if (nReadBytes==0) 
		{
			CloseHandle(FileData);
			return len;//  ,     57.     0 ,        .
		}
		//     57,    3,          .
		
		// .
		j=0;
		SourceLen+=nReadBytes;//      .
		for(unsigned int i=0;i<nReadBytes;i+=3)//   
		{
			//memcpy(&p,ReadData+i,3);// . .
			
			p=ReadData[i+2]+ReadData[i+1]*256+ReadData[i]*65536;// ***
			for(unsigned char i1=0;i1<3;i1++)
			{
				tmpchar=p;
				tmpchar<<=2;//  6 
				tmpchar>>=2;//
				ResData[j+3-i1]=tmpchar;
				p>>=6;//   6 
			}
			ResData[j]=p;// p    6 .      .
			j+=4;
		}

		len+=j+1;//j -    ResData,    -  
		
		//       
		if(len<=length)//    
		{
			for(unsigned char i1=0;i1<j;i1++)//  j 
			{
				buffer[CurResBufferPos+i1]=base64[ResData[i1]];//-1   uucode    
			}
			
			buffer[CurResBufferPos+j]='\n';
			CurResBufferPos+=j+1;
		}
		else return 0;
		

	}
	while(nReadBytes==57);

	//         3  1,       (    )   =
	//        3  2,       =.
	char pad=(3-SourceLen%3)%3;//,   =  .     ,  0  =,     3.
	while(pad>0)
	{
		buffer[CurResBufferPos-1-pad]='=';//   buffer  '\n',    .    .
		pad--;
	}
	CloseHandle(FileData);
	return len;
}
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	long size;
	char CodedData[150000];
 	if(!(size=uuencode("NotePad1.exe",CodedData,150000))) 
	{
		MessageBox(NULL,"Net Mesta for uu","gluk",MB_OK);
		exit(2);
	}
	// TODO: Place code here.
//begin for debug purposes
	FileData=CreateFile("coded",GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0);
	bool result=WriteFile(FileData,CodedData,size,&nReadBytes,0);
	CloseHandle(FileData);
//end
	
	
	//  ,   uudecode
	uudecode(CodedData,size,"res.du");//size -  ,     .

 	if(!(size=base64encode("Perl.exe",CodedData,150000))) // ,     .  ,    ... 
	{
		MessageBox(NULL,"Net Mesta for base64","gluk",MB_OK);
		exit(3);
	}
//begin for debug purposes
	FileData=CreateFile("coded1",GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0);
	result=WriteFile(FileData,CodedData,size,&nReadBytes,0);
	CloseHandle(FileData);
//end
	
	err = WSAStartup( 0x101, &W );
		if(err!=0) exit(1);

	Sock=socket(AF_INET,SOCK_STREAM,0);
	Saddr.sin_family=AF_INET;
	Saddr.sin_port=htons(25);
	hostent *H=gethostbyname("smtp.mail.ru");
//	Saddr.sin_addr.s_addr=inet_addr("213.180.193.56");
	Saddr.sin_addr.s_addr=/*0x291743c2;*/ *((unsigned long *) H->h_addr);
	
	res=connect(Sock,(sockaddr*)&Saddr,sizeof(Saddr));
	if (res!=0) return false;
	MessageBox(NULL,"connect","est",MB_OK);

	res=recv(Sock,text,1024,0);
	strcpy(text,"HELO mail.ru\r\n");
	res=send(Sock,text,strlen(text),0);
	res=recv(Sock,text,1024,0);
	strcpy(text,"MAIL FROM: <s_daemon@yahoo.com> \r\n");
	res=send(Sock,text,strlen(text),0);
	strcpy(text,"RCPT TO: <slndm@mail.ru> \r\n");
	res=send(Sock,text,strlen(text),0);
	res=recv(Sock,text,1024,0);
	strcpy(text,"DATA\r\n");
	res=send(Sock,text,strlen(text),0);
	
	strcpy(text,"FROM: smtm.mit.ru\r\n");
	res=send(Sock,text,strlen(text),0);
	strcpy(text,"TO: fornajort@mail.ru\r\n");
	res=send(Sock,text,strlen(text),0);
	strcpy(text,"MESSAGE_ID:<zzz> \r\nSUBJECT: <test>\r\n");
	res=send(Sock,text,strlen(text),0);

// >>>
//   -----------------      ,       base64
	send(Sock,"MIME-Version: 1.0\r\n",19,0);
	strcpy(text,"Content-Type: multipart/mixed; boundary=\"--------bound--\"\r\n");//  boundary     "--". 
	send(Sock,text,strlen(text),0);
	send(Sock,"\r\n",2,0);
	send(Sock,"----------bound--\r\n",19,0);
	strcpy(text,"Content-Type: text/plain; charset=us-ascii\r\nContent-Transfer-Encoding: 7bit\r\n");
	send(Sock,text,strlen(text),0);
	send(Sock,"\r\n",2,0);
//   -----------------   MIME 
// <<<	
	strcpy(text,"info\r\n");// 
	res=send(Sock,text,strlen(text),0);
// >>>	

	send(Sock,"----------bound--\r\n",19,0);
	strcpy(text,"Content-Type: application/x-msdownload; name=\"Perl.exe\"\r\nContent-Transfer-Encoding: base64\r\nContent-Disposition: attachment; filename=\"Perl.exe\"\r\n");

	res=send(Sock,text,strlen(text),0);
	send(Sock,"\r\n",2,0);

	if(size=base64encode("Perl.exe",CodedData,150000)) 
	{
		send(Sock,CodedData,size,0);
	}
	else send(Sock,"FAILED",6,0);

	send(Sock,"\r\n",2,0);

	send(Sock,"----------bound--\r\n",19,0);
//     uuencode. 
	strcpy(text,"Content-Type: application/x-msdownload; name=\"notepad.exe\"\r\nContent-Transfer-Encoding: x-uue\r\nContent-Disposition: attachment; filename=\"notepad.exe\"\r\n");
	send(Sock,text,strlen(text),0);
	send(Sock,"\r\n",2,0);
// <<<	

	// 
//	strcpy(text,"Attachment: NotePad2.exe\r\nEncoding: UUEncoded\r\n");
	if(size=uuencode("Notepad1.exe",CodedData,150000)) 
	{
	
		strcpy(text,"begin 600 NotePad.exe\r\n");
		send(Sock,text,strlen(text),0);
		send(Sock,CodedData,size,0);//     uuencode
		strcpy(text,"`\nend\n\n");
		send(Sock,text,strlen(text),0);
	}
	send(Sock,"\r\n",2,0);
// >>>
	send(Sock,"----------bound--\r\n",19,0);
	
// <<<


	strcpy(text,"\r\n.\r\n");
	res=send(Sock,text,strlen(text),0);
	
	strcpy(text,"QUIT\r\n");
	res=send(Sock,text,strlen(text),0);
	res=recv(Sock,text,1024,0);
	closesocket(Sock);//     


	return 0;
}



